#!/bin/sh
mkdir -p /usr/local/mmog/cluster/cfg/update/
env luajit <<EOF

local msgpack = require('msgpack')
local utils = require('utils')
local ffi = require('ffi')

--list.lua {{{
local f = io.popen('find . -name "*.lua" -not -name "init.lua" -not -name "threadpool.lua"', 'r')
local m = {}
while true do 
    local line = f:read('*l')
    if not line then break end 
    if line ~= './list.lua' then 
        local ff = io.open(line, 'r')
        local ss = ff:read('*a')
        local md5sum = utils.md5.sumhexa(ss)
        print(line, md5sum)
        ff:close()
        m[line] = md5sum
    end 
end 
f:close()

local fff = io.open('./list.lua', 'w+')
fff:write('return {\n')
for k, v in pairs(m) do
    k = k:gsub('^%./', ''):gsub('%.lua$',''):gsub('/','.')
    fff:write('\t ["' .. k .. '"] = "' .. v .. '",\n')
end 
fff:write('}')
fff:close()

--}}}
--list.json
--{{{
local fff = io.open('/usr/local/mmog/cluster/cfg/update/list.json', 'w+')
fff:write('{\n')
for k, v in pairs(m) do
    k = k:gsub('^%./', ''):gsub('%.lua$',''):gsub('/','.')
    fff:write('\t "' .. k .. '" : "' .. v .. '",\n')
end 
fff:write('}')
fff:close()

--}}}


--encode lua {{{

local f = io.popen('find . -name "*.lua" -not -name "init.lua" -not -name "threadpool.lua"', 'r')
while true do 
    local line = f:read('*l')
    if not line then break end 
    local ff = io.open(line, 'r')
    local ss = ff:read('*a')
    ff:close()
    ffi.copy(utils.bigbuff, ss)
    utils.ffi_bigbuff_t.len = #ss
    local encrypt_len = utils.xxtea.encrypt(utils.ffi_bigbuff_t)
    local b64string = utils.base64.to_base64(ffi.cast('char*', utils.ffi_bigbuff_t), encrypt_len)
    line = line:gsub('^%./', ''):gsub('%.lua$',''):gsub('/','.')
    local fff = io.open('/usr/local/mmog/cluster/cfg/update/'.. line .. '.data', 'w+')
    fff:write(b64string)
    fff:close()

end 
f:close()


--}}}


-- check {{{
local f = io.popen('find . -name "*.lua" -not -name "init.lua" -not -name "threadpool.lua"', 'r')
while true do 
    local line = f:read('*l')
    if not line then break end 
    --原始字符
    local ff = io.open(line, 'r')
    local ss = ff:read('*a')
    ff:close()

    --加密字符 
    line = line:gsub('^%./', ''):gsub('%.lua$',''):gsub('/','.')
    local fff = io.open('/usr/local/mmog/cluster/cfg/update/'.. line .. '.data', 'r')
    local eee = fff:read('*a')
    fff:close()
    local bin, len = utils.base64.from_base64(eee)
    local ffi_buffer_t = utils.xxtea.decrypt(bin, len)
    local ddd = ffi.string(ffi_buffer_t.data, ffi_buffer_t.len)
    assert(ss == ddd)
end
f:close()
-- }}}


EOF
